#!/usr/bin/env node
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.iotsfjs = void 0;
var crypto = require("crypto");
var gen = require("io-ts-codegen");
var path = require("path");
var printc_1 = require("./codegen/printc");
var hyper_1 = require("./vocab/hyper");
/* eslint-disable @typescript-eslint/no-use-before-define */
function iotsfjs(inputSchema, args, stderr) {
    function capitalize(word) {
        var empty = '';
        var _a = __read(word.split(empty)), c = _a[0], cs = _a.slice(1);
        if (typeof c === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        return __spreadArray([c.toUpperCase()], __read(cs), false).join(empty);
    }
    // ALL_UPPER-CASE => ALL_UPPERCASE
    function typenameFromAllCaps(allCaps) {
        return allCaps.split('-').join('');
    }
    // random-caseCombination => RandomCaseCombination
    function typenameFromKebab(kebab) {
        var typename = kebab.split('-').map(capitalize).join('');
        return typename;
    }
    function isAllCaps(randomCase) {
        return randomCase === randomCase.toUpperCase();
    }
    function typenameFromRandom(randomCase) {
        if (isAllCaps(randomCase)) {
            return typenameFromAllCaps(randomCase);
        }
        return typenameFromKebab(randomCase);
    }
    function getDefaultExport(jsonFilePath) {
        var _a = __read(jsonFilePath.split('/').slice(-1), 1), withoutPath = _a[0];
        if (typeof withoutPath === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        var _b = __read(withoutPath.split('.json'), 1), withoutExtension = _b[0];
        if (typeof withoutExtension === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        return typenameFromRandom(withoutExtension);
    }
    function updateFailure(level) {
        if (returnCode === ErrorCode.ERROR) {
            return;
        }
        // eslint-disable-next-line fp/no-mutation
        returnCode = level;
    }
    function reportError(level, message) {
        var lines = [level + ": " + message, "  in " + args.inputFile];
        stderr.write(lines.join('\n').concat('\n'));
    }
    function error(message) {
        updateFailure(ErrorCode.ERROR);
        reportError('ERROR', message);
        var escalate = "throw new Error('schema conversion failed')";
        return gen.customCombinator(escalate, escalate);
    }
    function warning(message) {
        updateFailure(ErrorCode.WARNING);
        reportError('WARNING', message);
    }
    function info(message) {
        reportError('INFO', message);
    }
    function notImplemented(item, kind) {
        var isOutsideRoot = supportedAtRoot.includes(item);
        var where = isOutsideRoot ? 'outside top-level definitions' : '';
        var message = [item, kind, 'not supported', where]
            .filter(function (s) { return s.length > 0; })
            .join(' ');
        warning(message);
    }
    function parseRef(ref) {
        var parts = ref.split('#');
        if (parts.length === 1) {
            var _a = __read(parts, 1), filePath_1 = _a[0];
            if (typeof filePath_1 === 'undefined') {
                // eslint-disable-next-line fp/no-throw
                throw new Error('assert false');
            }
            return { filePath: filePath_1, variableName: getDefaultExport(filePath_1) };
        }
        if (parts.length > 2) {
            // eslint-disable-next-line fp/no-throw
            throw new Error('unknown ref format');
        }
        var _b = __read(parts, 2), filePath = _b[0], jsonPath = _b[1];
        if (typeof jsonPath === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        var jsonPathParts = jsonPath.split('/');
        if (jsonPathParts.length !== 3) {
            // eslint-disable-next-line fp/no-throw
            throw new Error('unknown ref format');
        }
        var _c = __read(jsonPathParts, 3), empty = _c[0], definitions = _c[1], name = _c[2];
        if (empty !== '') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('unknown ref format');
        }
        if (definitions !== 'definitions') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('unknown ref format');
        }
        if (typeof name === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        var variableName = typenameFromKebab(name);
        if (typeof filePath === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        return { filePath: filePath, variableName: variableName };
    }
    function checkFormat(jx, format) {
        if (format === 'ipv4') {
            return "( typeof " + jx + " !== 'string' || ((octets) => octets.length === 4 && octets.map(Number).every((octet) => Number.isInteger(octet) && octet >= 0x00 && octet <= 0xff))(" + jx + ".split('.')) )";
        }
        notImplemented(format, 'format');
        return String(true);
    }
    function checkPattern(jx, pattern) {
        var stringLiteral = JSON.stringify(pattern);
        return "( typeof " + jx + " !== 'string' || " + jx + ".match(RegExp(" + stringLiteral + ", 'u')) !== null )";
    }
    function checkMinLength(jx, minLength) {
        return "( typeof " + jx + " !== 'string' || " + jx + ".length >= " + minLength + " )";
    }
    function checkMaxLength(jx, maxLength) {
        return "( typeof " + jx + " !== 'string' || " + jx + ".length <= " + maxLength + " )";
    }
    function checkMinimum(jx, minimum) {
        return "( typeof " + jx + " !== 'number' || " + jx + " >= " + minimum + " )";
    }
    function checkMaximum(jx, maximum) {
        return "( typeof " + jx + " !== 'number' || " + jx + " <= " + maximum + " )";
    }
    function checkMultipleOf(jx, divisor) {
        return "( typeof " + jx + " !== 'number' || " + jx + " % " + divisor + " === 0 )";
    }
    function checkInteger(jx) {
        return "( Number.isInteger(" + jx + ") )";
    }
    function checkMinItems(jx, minItems) {
        return "( Array.isArray(" + jx + ") === false || " + jx + ".length >= " + minItems + " )";
    }
    function checkMaxItems(jx, maxItems) {
        return "( Array.isArray(" + jx + ") === false || " + jx + ".length <= " + maxItems + " )";
    }
    function checkUniqueItems(jx) {
        return "( Array.isArray(" + jx + ") === false || " + jx + ".length === [...new Set(" + jx + ")].length )";
    }
    function generateChecks(jx, schema) {
        var checks = __spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], __read((schema.pattern ? [checkPattern(jx, schema.pattern)] : [])), false), __read((schema.format ? [checkFormat(jx, schema.format)] : [])), false), __read((schema.minLength ? [checkMinLength(jx, schema.minLength)] : [])), false), __read((schema.maxLength ? [checkMaxLength(jx, schema.maxLength)] : [])), false), __read((schema.minimum ? [checkMinimum(jx, schema.minimum)] : [])), false), __read((schema.maximum ? [checkMaximum(jx, schema.maximum)] : [])), false), __read((schema.multipleOf ? [checkMultipleOf(jx, schema.multipleOf)] : [])), false), __read((schema.type === 'integer' ? [checkInteger(jx)] : [])), false), __read((schema.minItems ? [checkMinItems(jx, schema.minItems)] : [])), false), __read((schema.maxItems ? [checkMaxItems(jx, schema.maxItems)] : [])), false), __read((schema.uniqueItems === true ? [checkUniqueItems(jx)] : [])), false);
        if (checks.length < 1) {
            return 'true';
        }
        return checks.join(' && ');
    }
    function calculateImportPath(filePath) {
        var e_3, _a;
        var _b = __read(filePath.split('.json'), 1), withoutSuffix = _b[0];
        if (typeof withoutSuffix === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        if (withoutSuffix.startsWith(args.base)) {
            var relativePath = path.relative(documentBase, withoutSuffix);
            if (relativePath.startsWith('.')) {
                return relativePath;
            }
            return './'.concat(relativePath);
        }
        try {
            // eslint-disable-next-line fp/no-loops
            for (var imports_1 = __values(imports), imports_1_1 = imports_1.next(); !imports_1_1.done; imports_1_1 = imports_1.next()) {
                var _c = __read(imports_1_1.value, 2), uri = _c[0], location_1 = _c[1];
                if (withoutSuffix.startsWith(uri)) {
                    return location_1.concat(withoutSuffix.slice(uri.length));
                }
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (imports_1_1 && !imports_1_1.done && (_a = imports_1.return)) _a.call(imports_1);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return './'.concat(withoutSuffix);
    }
    function importBaseName(filePath) {
        var _a = __read(filePath.split('/').reverse(), 1), withoutPath = _a[0];
        if (typeof withoutPath === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        var _b = __read(withoutPath.split('.json'), 1), basefile = _b[0];
        if (typeof basefile === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        var typeName = typenameFromKebab(basefile);
        return typeName.concat('_');
    }
    function importHashName(refString) {
        if (args.importHashLength === 0) {
            return '';
        }
        var _a = __read(refString.split('#'), 1), withoutFragment = _a[0];
        if (typeof withoutFragment === 'undefined') {
            // eslint-disable-next-line fp/no-throw
            throw new Error('assert false');
        }
        var fullDigest = crypto
            .createHash(args.importHashAlgorithm)
            .update(withoutFragment)
            .digest('hex');
        var shortDigest = fullDigest.slice(0, args.importHashLength);
        return shortDigest.concat('_');
    }
    function calculateImportName(filePath, refString) {
        var baseName = importBaseName(filePath);
        var hashName = importHashName(refString);
        return baseName.concat(hashName);
    }
    function isRefObject(schema) {
        if (schema.hasOwnProperty('$ref') === false) {
            return false;
        }
        if (typeof schema['$ref'] === 'string') {
            return true;
        }
        // eslint-disable-next-line fp/no-throw
        throw new Error('broken input');
    }
    function fromRef(refObject) {
        var refString = refObject.$ref, _comment = refObject.$comment, extra = __rest(refObject, ["$ref", "$comment"]);
        if (Object.keys(extra).length) {
            warning("unexpected key in a $ref object");
        }
        // eslint-disable-next-line fp/no-let
        var ref;
        try {
            // eslint-disable-next-line fp/no-mutation
            ref = parseRef(refString);
        }
        catch (_a) {
            return error('Failed to parse reference');
        }
        if (ref.filePath === '') {
            return gen.customCombinator(ref.variableName, ref.variableName, [ref.variableName]);
        }
        var importName = calculateImportName(ref.filePath, refString);
        var importPath = calculateImportPath(ref.filePath);
        imps.add("import * as " + importName + " from '" + importPath + "';");
        var variableRef = importName + "." + ref.variableName;
        return gen.customCombinator(variableRef, variableRef, [importName]);
    }
    function isSupported(feature, isRoot) {
        if (supportedEverywhere.includes(feature)) {
            return true;
        }
        if (isRoot) {
            return supportedAtRoot.includes(feature);
        }
        return supportedOutsideRoot.includes(feature);
    }
    function fromType(schema) {
        if (typeof schema.type === 'undefined') {
            return [];
        }
        var types = Array.isArray(schema.type) ? schema.type : [schema.type];
        var combinators = types.flatMap(function (t) {
            switch (t) {
                case 'string':
                    return [gen.stringType];
                case 'number':
                case 'integer':
                    return [gen.numberType];
                case 'boolean':
                    return [gen.booleanType];
                case 'null':
                    if (args.maskNull) {
                        helpers.add(nullHelper);
                        return [Null];
                    }
                    return [gen.nullType];
                case 'array':
                    if (schema.hasOwnProperty('items')) {
                        return []; // trust items validator to validate array
                    }
                    return [gen.unknownArrayType];
                case 'object':
                    if (schema.hasOwnProperty('properties')) {
                        return []; // trust properties validator to validate object
                    }
                    if (schema.hasOwnProperty('patternProperties')) {
                        return []; // trust pattern properties validator to validate object
                    }
                    if (schema.hasOwnProperty('propertyNames')) {
                        return []; // trust property names validator to validate object
                    }
                    if (schema.hasOwnProperty('additionalProperties')) {
                        return []; // trust additional properties validator to validate object
                    }
                    return [gen.unknownRecordType];
                default:
                    notImplemented(JSON.stringify(schema.type), 'type');
                    return [gen.unknownType];
            }
        });
        return genUnionCombinator(combinators);
    }
    function fromProperties(schema) {
        if ('properties' in schema && typeof schema.properties !== 'undefined') {
            if (schema.type !== 'object') {
                // eslint-disable-next-line fp/no-throw
                throw new Error('properties keyword is not supported outside explicit object definitions. See https://github.com/maasglobal/io-ts-from-json-schema/issues/33');
            }
            var combinator = gen.partialCombinator(Object.entries(schema.properties).map(function (_a) {
                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                return gen.property(key, fromSchema(value));
            }));
            return [combinator];
        }
        return [];
    }
    function fromPropertyNames(schema) {
        if ('propertyNames' in schema && typeof schema.propertyNames !== 'undefined') {
            if (schema.type !== 'object') {
                // eslint-disable-next-line fp/no-throw
                throw new Error('propertyNames keyword is not supported outside explicit object definitions. See https://github.com/maasglobal/io-ts-from-json-schema/issues/33');
            }
            return [gen.recordCombinator(fromSchema(schema.propertyNames), gen.unknownType)];
        }
        return [];
    }
    function fromPatternProperties(schema) {
        var _a;
        if ('patternProperties' in schema &&
            typeof schema.patternProperties !== 'undefined') {
            if (schema.type !== 'object') {
                // eslint-disable-next-line fp/no-throw
                throw new Error('patternProperties keyword is not supported outside explicit object definitions. See https://github.com/maasglobal/io-ts-from-json-schema/issues/33');
            }
            // the mapping from pattern to item is lost in the process
            // See https://github.com/microsoft/TypeScript/issues/6579
            warning('patternProperty support has limitations');
            // The Record must also support non-pattern properties
            var exactPairs = Object.entries((_a = schema.properties) !== null && _a !== void 0 ? _a : {}).map(function (_a) {
                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                return ["^" + key + "$", value];
            });
            var fuzzyPairs = Object.entries(schema.patternProperties);
            var allPairs = exactPairs.concat(fuzzyPairs);
            var valueCombinators = allPairs.map(function (_a) {
                var _b = __read(_a, 2), _key = _b[0], value = _b[1];
                return fromSchema(value);
            });
            var _b = __read(genUnionCombinator(valueCombinators), 1), valueCombinator = _b[0];
            if (typeof valueCombinator !== 'undefined') {
                return [gen.recordCombinator(gen.stringType, valueCombinator)];
            }
        }
        return [];
    }
    function fromAdditionalProperties(schema) {
        if ('additionalProperties' in schema &&
            typeof schema.additionalProperties !== 'undefined') {
            if (schema.type !== 'object') {
                // eslint-disable-next-line fp/no-throw
                throw new Error('additionalProperties keyword is not supported outside explicit object definitions. See https://github.com/maasglobal/io-ts-from-json-schema/issues/33');
            }
            if (schema.additionalProperties === false) {
                // avoid problems related to Record<string, never>
                return [];
            }
            return [
                gen.recordCombinator(gen.stringType, fromSchema(schema.additionalProperties)),
            ];
        }
        if (schema.type === 'object') {
            return [gen.recordCombinator(gen.stringType, gen.unknownType)];
        }
        return [];
    }
    function fromPropertyRules(schema) {
        return genIntersectionCombinator(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], __read(fromProperties(schema)), false), __read(fromPropertyNames(schema)), false), __read(fromPatternProperties(schema)), false), __read(fromAdditionalProperties(schema)), false));
    }
    function fromRequired(schema) {
        if ('required' in schema && typeof schema.required !== 'undefined') {
            var combinator = gen.typeCombinator(schema.required.map(function (key) {
                helpers.add(definedHelper);
                return gen.property(key, Defined);
            }));
            return [combinator];
        }
        return [];
    }
    function fromObjectKeywords(schema) {
        return __spreadArray(__spreadArray([], __read(fromPropertyRules(schema)), false), __read(fromRequired(schema)), false);
    }
    function fromItems(schema) {
        if ('items' in schema && typeof schema.items !== 'undefined') {
            if (schema.type !== 'array') {
                // eslint-disable-next-line fp/no-throw
                throw new Error('items keyword is not supported outside explicit array definitions. See https://github.com/maasglobal/io-ts-from-json-schema/issues/33');
            }
            if (schema.items === true) {
                // anything goes
                return [];
            }
            if (schema.items === false) {
                // no item is valid, empty tuple
                return [gen.tupleCombinator([])];
            }
            if (schema.items instanceof Array) {
                // tuple
                if ('additionalItems' in schema && schema.additionalItems === false) {
                    var combinators = schema.items.map(function (s) { return fromSchema(s); });
                    return [gen.tupleCombinator(combinators)];
                }
                // eslint-disable-next-line fp/no-throw
                throw new Error('tuples with ...rest are not supported, set additionalItems false');
            }
            // array
            return [gen.arrayCombinator(fromSchema(schema.items))];
        }
        return [];
    }
    function fromContains(schema) {
        if ('contains' in schema && typeof schema.contains !== 'undefined') {
            warning('contains field not supported');
        }
        return [];
    }
    function fromArrayKeywords(schema) {
        return __spreadArray(__spreadArray([], __read(fromItems(schema)), false), __read(fromContains(schema)), false);
    }
    function fromEnum(schema) {
        if ('enum' in schema && typeof schema.enum !== 'undefined') {
            var combinators = schema.enum.map(function (s) {
                if (s === null) {
                    if (args.maskNull) {
                        helpers.add(nullHelper);
                        return Null;
                    }
                    return gen.nullType;
                }
                switch (typeof s) {
                    case 'string':
                    case 'boolean':
                    case 'number':
                        return gen.literalCombinator(s);
                }
                // eslint-disable-next-line fp/no-throw
                throw new Error(typeof s + "s are not supported as part of ENUM");
            });
            return genUnionCombinator(combinators);
        }
        return [];
    }
    function fromConst(schema) {
        if ('const' in schema && typeof schema.const !== 'undefined') {
            switch (typeof schema.const) {
                case 'string':
                case 'boolean':
                case 'number':
                    return [gen.literalCombinator(schema.const)];
            }
            // eslint-disable-next-line fp/no-throw
            throw new Error(typeof schema.const + "s are not supported as part of CONST");
        }
        return [];
    }
    function fromAllOf(schema) {
        if ('allOf' in schema && typeof schema.allOf !== 'undefined') {
            var combinators = schema.allOf.map(function (s) { return fromSchema(s); });
            if (combinators.length === 1) {
                var _a = __read(combinators, 1), combinator = _a[0];
                if (typeof combinator === 'undefined') {
                    // eslint-disable-next-line fp/no-throw
                    throw new Error('assert false');
                }
                return [combinator];
            }
            return [gen.intersectionCombinator(combinators)];
        }
        return [];
    }
    function fromAnyOf(schema) {
        if ('anyOf' in schema && typeof schema.anyOf !== 'undefined') {
            var combinators = schema.anyOf.map(function (s) { return fromSchema(s); });
            return genUnionCombinator(combinators);
        }
        return [];
    }
    function fromSchema(schema, isRoot) {
        if (isRoot === void 0) { isRoot = false; }
        if (typeof schema === 'boolean') {
            imps.add("import * as t from 'io-ts';");
            if (schema) {
                // accept anything
                return gen.unknownType;
            }
            else {
                // accept nothing
                return genNeverType;
            }
        }
        if (isRoot === false &&
            typeof schema.type === 'string' &&
            ['string', 'number', 'integer'].includes(schema.type)) {
            info("primitive type \"" + schema.type + "\" used outside top-level definitions");
        }
        // eslint-disable-next-line fp/no-loops
        for (var key in schema) {
            if (isSupported(key, isRoot) !== true) {
                notImplemented(key, 'field');
            }
        }
        if (isRefObject(schema)) {
            return fromRef(schema);
        }
        imps.add("import * as t from 'io-ts';");
        var combinators = __spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], __read(fromType(schema)), false), __read(fromObjectKeywords(schema)), false), __read(fromArrayKeywords(schema)), false), __read(fromEnum(schema)), false), __read(fromConst(schema)), false), __read(fromAllOf(schema)), false), __read(fromAnyOf(schema)), false);
        if (combinators.length > 1) {
            return gen.intersectionCombinator(combinators);
        }
        if (combinators.length === 1) {
            var _a = __read(combinators, 1), combinator = _a[0];
            if (typeof combinator === 'undefined') {
                // eslint-disable-next-line fp/no-throw
                throw new Error('assert false');
            }
            return combinator;
        }
        if (generateChecks('x', schema).length > 1) {
            // skip checks
            return gen.unknownType;
        }
        // eslint-disable-next-line fp/no-throw
        throw new Error("unknown schema: " + JSON.stringify(schema));
    }
    function extractTitleValue(schema) {
        if ('$ref' in schema) {
            warning('skipping title value handling for $ref object');
            return undefined;
        }
        return schema['title'];
    }
    function extractDescriptionValue(schema) {
        if ('$ref' in schema) {
            warning('skipping description value handling for $ref object');
            return undefined;
        }
        return schema['description'];
    }
    function extractExamples(schema) {
        if ('$ref' in schema) {
            warning('skipping examples handling for $ref object');
            return [];
        }
        var examples = schema.examples;
        if (examples instanceof Array) {
            return examples;
        }
        if (typeof examples === 'undefined') {
            return [];
        }
        // eslint-disable-next-line fp/no-throw
        throw new Error('Unexpected format of examples');
    }
    function extractInvalid(schema) {
        if ('$ref' in schema) {
            warning('skipping invalid examples handling for $ref object');
            return {};
        }
        var invalid = schema.invalid;
        if (typeof invalid === 'object') {
            return invalid;
        }
        if (typeof invalid === 'undefined') {
            return {};
        }
        // eslint-disable-next-line fp/no-throw
        throw new Error('Unexpected format of invalid examples');
    }
    function extractDefaultValue(schema) {
        if ('$ref' in schema) {
            warning('skipping default value handling for $ref object');
            return undefined;
        }
        return schema['default'];
    }
    function extractMinimumValue(schema) {
        if ('$ref' in schema) {
            warning('skipping minimum value handling for $ref object');
            return undefined;
        }
        return schema['minimum'];
    }
    function extractMaximumValue(schema) {
        if ('$ref' in schema) {
            warning('skipping maximum value handling for $ref object');
            return undefined;
        }
        return schema['maximum'];
    }
    function extractMeta(scem) {
        if (typeof scem === 'boolean') {
            // note that in this context true is any and false is never
            return {
                title: undefined,
                description: undefined,
                examples: [],
                invalid: {},
                defaultValue: undefined,
                minimumValue: undefined,
                maximumValue: undefined,
            };
        }
        if (isRefObject(scem)) {
            // ref's do not have meta data
            return {
                title: undefined,
                description: undefined,
                examples: [],
                invalid: {},
                defaultValue: undefined,
                minimumValue: undefined,
                maximumValue: undefined,
            };
        }
        return {
            title: extractTitleValue(scem),
            description: extractDescriptionValue(scem),
            examples: extractExamples(scem),
            invalid: extractInvalid(scem),
            defaultValue: extractDefaultValue(scem),
            minimumValue: extractMinimumValue(scem),
            maximumValue: extractMaximumValue(scem),
        };
    }
    function fromDefinitions(definitions2) {
        var definitions = definitions2 !== null && definitions2 !== void 0 ? definitions2 : {};
        return Object.entries(definitions).flatMap(function (_a) {
            var _b = __read(_a, 2), k = _b[0], v = _b[1];
            var scem = v;
            var name = capitalize(k);
            if (typeof scem === 'boolean') {
                return [
                    {
                        meta: extractMeta(scem),
                        dec: gen.typeDeclaration(name, gen.brandCombinator(scem ? gen.unknownType : genNeverType, function (_x) { return String(scem); }, name), true),
                    },
                ];
            }
            if (isRefObject(scem)) {
                // ref's do not have meta data
                return [
                    {
                        meta: extractMeta(scem),
                        dec: gen.typeDeclaration(name, gen.brandCombinator(fromRef(scem), function (_x) { return String(true); }, name), true),
                    },
                ];
            }
            return [
                {
                    meta: extractMeta(scem),
                    dec: gen.typeDeclaration(name, gen.brandCombinator(fromSchema(scem, true), function (jx) { return generateChecks(jx, scem); }, name), true),
                },
            ];
        });
    }
    function fromRoot(root) {
        if (root.hasOwnProperty('$schema') === false) {
            warning("missing $schema declaration");
        }
        imps.add("import * as t from 'io-ts';");
        exps.add("export default " + defaultExport + ";");
        return [
            {
                meta: __assign(__assign({}, extractMeta(root)), { 
                    // root schema info is printed in the beginning of the file
                    title: defaultExport, description: 'The default export. More information at the top.' }),
                dec: gen.typeDeclaration(defaultExport, gen.brandCombinator(isRefObject(root)
                    ? error('schema root can not be a $ref object')
                    : fromSchema(root, true), function (jx) { return generateChecks(jx, root); }, defaultExport), true),
            },
        ];
    }
    function fromFile(schema) {
        var namedDefs = fromDefinitions(schema.definitions);
        if (namedDefs.map(function (_a) {
            var name = _a.dec.name;
            return name;
        }).includes(defaultExport)) {
            warning('naming clash, ignoring default export');
            return namedDefs;
        }
        var rootDef = fromRoot(schema);
        var hyperDef = (0, hyper_1.fromHyper)({
            defaultExport: defaultExport,
            extractMeta: extractMeta,
            imps: imps,
            exps: exps,
            fromSchema: fromSchema,
            generateChecks: generateChecks,
        })(schema);
        return namedDefs.concat(rootDef).concat(hyperDef);
    }
    function constructDefs(defInputs) {
        var metas = {};
        defInputs.forEach(function (defInput) {
            // eslint-disable-next-line fp/no-mutation
            metas[defInput.dec.name] = defInput.meta;
        });
        var decs = defInputs.map(function (_a) {
            var dec = _a.dec;
            return dec;
        });
        return gen.sort(decs).map(function (dec) {
            var _a, _b;
            var typeName = dec.name;
            var meta = metas[typeName];
            if (typeof meta === 'undefined') {
                // eslint-disable-next-line fp/no-throw
                throw new Error('assert false');
            }
            var title = (_a = meta.title) !== null && _a !== void 0 ? _a : typeName;
            var description = (_b = meta.description) !== null && _b !== void 0 ? _b : 'The purpose of this remains a mystery';
            var examples = meta.examples || [];
            var invalid = meta.invalid || {};
            var defaultValue = meta.defaultValue;
            var minimumValue = meta.minimumValue;
            var maximumValue = meta.maximumValue;
            var staticType = gen.printStatic(dec);
            var runtimeType = (0, printc_1.printC)(dec)
                .concat('\n')
                .concat(gen.printRuntime(dec))
                .replace("const " + typeName + " ", "const " + typeName + ": " + typeName + "C ")
                .replace(/\ninterface /, '\nexport interface ');
            if (typeof meta.description !== 'string') {
                info('missing description');
            }
            if (examples.length > 0) {
                imps.add("import { NonEmptyArray } from 'fp-ts/lib/NonEmptyArray';");
                imps.add("import { nonEmptyArray } from 'io-ts-types/lib/nonEmptyArray';");
            }
            return {
                typeName: typeName,
                title: title,
                description: description,
                examples: examples,
                invalid: invalid,
                defaultValue: defaultValue,
                minimumValue: minimumValue,
                maximumValue: maximumValue,
                staticType: staticType,
                runtimeType: runtimeType,
            };
        });
    }
    var imports, genNeverType, genIntersectionCombinator, genUnionCombinator, definedHelper, Defined, nullHelper, Null, supportedEverywhere, supportedAtRoot, supportedOutsideRoot, documentBase, defaultExport, imps, helpers, exps, ErrorCode, OK, returnCode, inputs, defs, defs_1, defs_1_1, def, typeName, title, description, examples, invalid, defaultValue, minimumValue, maximumValue, staticType, runtimeType, examplesName, _a, _b, _c, b64, description_1, negativeTestCase, e_1_1, defaultName, minimumName, maximumName, e_2_1;
    var e_2, _d, e_1, _e;
    return __generator(this, function (_f) {
        switch (_f.label) {
            case 0:
                imports = args.import.map(function (imp) { return imp.split('^'); });
                genNeverType = gen.intersectionCombinator([
                    gen.literalCombinator(true),
                    gen.literalCombinator(false),
                ]);
                genIntersectionCombinator = function (combinators) {
                    if (combinators.length > 1) {
                        var intersection = gen.intersectionCombinator(combinators);
                        return [intersection];
                    }
                    var _a = __read(combinators, 1), first = _a[0];
                    if (typeof first === 'undefined') {
                        return [];
                    }
                    return [first];
                };
                genUnionCombinator = function (combinators) {
                    if (combinators.length > 1) {
                        var union = gen.unionCombinator(combinators);
                        return [union];
                    }
                    var _a = __read(combinators, 1), first = _a[0];
                    if (typeof first === 'undefined') {
                        return [];
                    }
                    return [first];
                };
                definedHelper = "\nexport type Defined = {} | null\nexport class DefinedType extends t.Type<Defined> {\n  readonly _tag: 'DefinedType' = 'DefinedType'\n  constructor() {\n    super(\n      'defined',\n      (u): u is Defined => typeof u !== 'undefined',\n      (u, c) => (this.is(u) ? t.success(u) : t.failure(u, c)),\n      t.identity\n    )\n  }\n}\nexport interface DefinedC extends DefinedType {}\nexport const Defined: DefinedC = new DefinedType()\n";
                Defined = gen.customCombinator('Defined', 'Defined');
                nullHelper = "\nexport interface NullBrand {\n  readonly Null: unique symbol\n}\nexport type NullC = t.BrandC<t.UnknownC, NullBrand>;\nexport const Null: NullC = t.brand(\n  t.unknown,\n  (n): n is t.Branded<unknown, NullBrand> => n === null,\n  'Null'\n)\nexport type Null = t.TypeOf<typeof Null>\n";
                Null = gen.customCombinator('Null', 'Null');
                supportedEverywhere = [
                    '$id',
                    '$comment',
                    'title',
                    'description',
                    'definitions',
                    'type',
                    'properties',
                    'propertyNames',
                    'patternProperties',
                    'required',
                    'additionalProperties',
                    'allOf',
                    'anyOf',
                    'enum',
                    'const',
                    'items',
                    'contains',
                    'additionalItems',
                ];
                supportedAtRoot = [
                    '$schema',
                    'minimum',
                    'maximum',
                    'multipleOf',
                    'minLength',
                    'maxLength',
                    'pattern',
                    'format',
                    'minItems',
                    'maxItems',
                    'uniqueItems',
                    'default',
                    'examples',
                    'invalid',
                    'links',
                ];
                supportedOutsideRoot = ['$ref'];
                documentBase = (function () {
                    var _a = __read(args.documentURI.split('/').reverse()), reversePath = _a.slice(1);
                    return reversePath.reverse().join('/');
                })();
                defaultExport = getDefaultExport(args.inputFile);
                imps = new Set();
                helpers = new Set();
                exps = new Set();
                (function (ErrorCode) {
                    ErrorCode[ErrorCode["WARNING"] = 1] = "WARNING";
                    ErrorCode[ErrorCode["ERROR"] = 2] = "ERROR";
                })(ErrorCode || (ErrorCode = {}));
                OK = 0;
                returnCode = OK;
                inputs = fromFile(inputSchema);
                defs = constructDefs(inputs);
                if (returnCode === ErrorCode.ERROR) {
                    // eslint-disable-next-line fp/no-throw
                    throw new Error('Bailing because of errors');
                }
                if (returnCode === ErrorCode.WARNING && args.strict) {
                    // eslint-disable-next-line fp/no-throw
                    throw new Error('Bailing because of warnings');
                }
                return [4 /*yield*/, '/*'];
            case 1:
                _f.sent();
                return [4 /*yield*/, ''];
            case 2:
                _f.sent();
                return [4 /*yield*/, "" + inputSchema.title];
            case 3:
                _f.sent();
                return [4 /*yield*/, "" + inputSchema.description];
            case 4:
                _f.sent();
                return [4 /*yield*/, ''];
            case 5:
                _f.sent();
                return [4 /*yield*/, '!!! AUTO GENERATED BY IOTSFJS REFRAIN FROM MANUAL EDITING !!!'];
            case 6:
                _f.sent();
                return [4 /*yield*/, 'See https://www.npmjs.com/package/io-ts-from-json-schema'];
            case 7:
                _f.sent();
                return [4 /*yield*/, ''];
            case 8:
                _f.sent();
                return [4 /*yield*/, '*/'];
            case 9:
                _f.sent();
                return [4 /*yield*/, ''];
            case 10:
                _f.sent();
                return [5 /*yield**/, __values(imps)];
            case 11:
                _f.sent();
                return [4 /*yield*/, ''];
            case 12:
                _f.sent();
                return [5 /*yield**/, __values(helpers)];
            case 13:
                _f.sent();
                return [4 /*yield*/, ''];
            case 14:
                _f.sent();
                return [4 /*yield*/, "export const schemaId = '" + inputSchema.$id + "';"];
            case 15:
                _f.sent();
                return [4 /*yield*/, ''];
            case 16:
                _f.sent();
                _f.label = 17;
            case 17:
                _f.trys.push([17, 46, 47, 48]);
                defs_1 = __values(defs), defs_1_1 = defs_1.next();
                _f.label = 18;
            case 18:
                if (!!defs_1_1.done) return [3 /*break*/, 45];
                def = defs_1_1.value;
                typeName = def.typeName, title = def.title, description = def.description, examples = def.examples, invalid = def.invalid, defaultValue = def.defaultValue, minimumValue = def.minimumValue, maximumValue = def.maximumValue, staticType = def.staticType, runtimeType = def.runtimeType;
                return [5 /*yield**/, __values(title.split('\n').map(function (line) { return "// " + line; }))];
            case 19:
                _f.sent();
                return [5 /*yield**/, __values(description.split('\n').map(function (line) { return "// " + line; }))];
            case 20:
                _f.sent();
                return [4 /*yield*/, staticType];
            case 21:
                _f.sent();
                return [4 /*yield*/, runtimeType];
            case 22:
                _f.sent();
                if (!(examples.length > 0)) return [3 /*break*/, 25];
                examplesName = 'examples'.concat(typeName);
                return [4 /*yield*/, "/** require('io-ts-validator').validator(nonEmptyArray(" + typeName + ")).decodeSync(" + examplesName + ") // => " + examplesName + " */"];
            case 23:
                _f.sent();
                return [4 /*yield*/, "export const " + examplesName + ": NonEmptyArray<" + typeName + "> = " + JSON.stringify(examples) + " as unknown as NonEmptyArray<" + typeName + ">;"];
            case 24:
                _f.sent();
                _f.label = 25;
            case 25:
                _f.trys.push([25, 31, 32, 33]);
                _a = (e_1 = void 0, __values(Object.entries(invalid))), _b = _a.next();
                _f.label = 26;
            case 26:
                if (!!_b.done) return [3 /*break*/, 30];
                _c = __read(_b.value, 2), b64 = _c[0], description_1 = _c[1];
                return [4 /*yield*/, "// NEGATIVE Test Case: " + description_1];
            case 27:
                _f.sent();
                negativeTestCase = Buffer.from(b64, 'base64').toString('utf8');
                return [4 /*yield*/, "/** require('io-ts-validator').validator(" + typeName + ").decodeEither(" + negativeTestCase + ")._tag // => 'Left' */"];
            case 28:
                _f.sent();
                _f.label = 29;
            case 29:
                _b = _a.next();
                return [3 /*break*/, 26];
            case 30: return [3 /*break*/, 33];
            case 31:
                e_1_1 = _f.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 33];
            case 32:
                try {
                    if (_b && !_b.done && (_e = _a.return)) _e.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
                return [7 /*endfinally*/];
            case 33:
                if (!(typeof defaultValue !== 'undefined')) return [3 /*break*/, 36];
                defaultName = 'default'.concat(typeName);
                return [4 /*yield*/, "/** require('io-ts-validator').validator(" + typeName + ").decodeSync(" + defaultName + ") // => " + defaultName + " */"];
            case 34:
                _f.sent();
                return [4 /*yield*/, "export const " + defaultName + ": " + typeName + " = " + JSON.stringify(defaultValue) + " as unknown as " + typeName + ";"];
            case 35:
                _f.sent();
                _f.label = 36;
            case 36:
                if (!(typeof minimumValue !== 'undefined')) return [3 /*break*/, 39];
                minimumName = 'minimum'.concat(typeName);
                return [4 /*yield*/, "/** require('io-ts-validator').validator(" + typeName + ").decodeSync(" + minimumName + ") // => " + minimumName + " */"];
            case 37:
                _f.sent();
                return [4 /*yield*/, "export const " + minimumName + ": " + typeName + " = " + JSON.stringify(minimumValue) + " as unknown as " + typeName + ";"];
            case 38:
                _f.sent();
                _f.label = 39;
            case 39:
                if (!(typeof maximumValue !== 'undefined')) return [3 /*break*/, 42];
                maximumName = 'maximum'.concat(typeName);
                return [4 /*yield*/, "/** require('io-ts-validator').validator(" + typeName + ").decodeSync(" + maximumName + ") // => " + maximumName + " */"];
            case 40:
                _f.sent();
                return [4 /*yield*/, "export const " + maximumName + ": " + typeName + " = " + JSON.stringify(maximumValue) + " as unknown as " + typeName + ";"];
            case 41:
                _f.sent();
                _f.label = 42;
            case 42: return [4 /*yield*/, ''];
            case 43:
                _f.sent();
                _f.label = 44;
            case 44:
                defs_1_1 = defs_1.next();
                return [3 /*break*/, 18];
            case 45: return [3 /*break*/, 48];
            case 46:
                e_2_1 = _f.sent();
                e_2 = { error: e_2_1 };
                return [3 /*break*/, 48];
            case 47:
                try {
                    if (defs_1_1 && !defs_1_1.done && (_d = defs_1.return)) _d.call(defs_1);
                }
                finally { if (e_2) throw e_2.error; }
                return [7 /*endfinally*/];
            case 48: return [5 /*yield**/, __values(exps)];
            case 49:
                _f.sent();
                return [4 /*yield*/, ''];
            case 50:
                _f.sent();
                return [4 /*yield*/, '// Success'];
            case 51:
                _f.sent();
                return [2 /*return*/];
        }
    });
}
exports.iotsfjs = iotsfjs;
