import * as gen from 'io-ts-codegen';
import { JSONSchema7 } from 'json-schema';
export declare type Examples = Array<unknown>;
export declare type Invalid = Record<string, string>;
export declare type Def = {
    typeName: string;
    title: string;
    description: string;
    examples: Examples;
    invalid: Invalid;
    defaultValue: unknown;
    minimumValue: unknown;
    maximumValue: unknown;
    staticType: string;
    runtimeType: string;
};
export declare type DefMeta = {
    title: JSONSchema7['title'];
    description: JSONSchema7['description'];
    examples: Examples;
    invalid: Invalid;
    defaultValue: JSONSchema7['default'];
    minimumValue: JSONSchema7['minimum'];
    maximumValue: JSONSchema7['maximum'];
};
export declare type DefInput = {
    meta: DefMeta;
    dec: gen.TypeDeclaration;
};
